/* ------------------------------- low.c ------------------------------------ */

#include <stdlib.h>
#include <time.h>
#include <conio.h>
#include <dos.h>

#include "grh.h"

uint	near _ReadPage = 0;
uint	near _WritePage = 0;
uint	near _GrType = GRT_NONE;
uint	near _GrSizeX = 0;
uint	near _GrSizeY = 0;
uint	near _GrWriteMode = 0;
long	near _ActiveBase = 0;
uint	near _GrBiosMode = 0;
ulong	near _BankSwitches = 0L;	/* stats */

#ifdef USE_DIVTAB
unsigned int	far divtab[2048] = {0};
#endif

extern void far
GrSetWriteMode (int mode)
{
	mode &= 0xff00;
	if (_GrWriteMode != mode) {
		_GrWriteMode = mode;
		_SetWM (mode);
	}
}

extern int far
GrSetBiosMode (n)
int	n;
{
	REGISTERS	regs;

	_GrBiosMode = n;

	if (n >= 0x100) {
		regs.ax = 0x4f02;
		regs.bx = _GrBiosMode;
	} else
		regs.ax = _GrBiosMode;
	return (int10 (&regs));
}

static void far _fastcall
_GrTabInit ()
{
	int		i;
	static int	divtabinit = 1;

	if (divtabinit) {
		divtabinit = 0;
#ifdef USE_DIVTAB
		divtab[0] = 0L;
		for (i = 1; i < sizeof(divtab)/sizeof(divtab[0]); ++i)
			divtab[i] = (unsigned int)(0x00010000L / i);
#endif
	}
}

extern void far
GrSetType (uint type, uint nbanks, uint width)
{
	_GrType = type & GRT_MASK;
	_SetCH (_GrType, nbanks, width);
	_GrTabInit ();
}

extern void far _fastcall
_GrSetPage (pread, pwrite)
int	pread;
int	pwrite;
{
	_SetPG (pread);

	_ReadPage = pread;
	_WritePage = pwrite;
}

extern uint far _fastcall
_GrGetPage ()
{
	return (_ReadPage);
}

extern uchar far * far _fastcall
_GrNewPage (xy)
ulong	xy;
{
	uint	page;

	page = (uint)(xy >> 16);
	if (page != _ReadPage)
		_GrSetPage (page, page);

	return (VGA_PAGE + (uint)xy);
}

static short far
_Disable (void)
{
	short	flags;

	_asm {
		pushf
		pop	flags
		cli
	}
	return (flags);
}

static void far
_Enable (short flags)
{
	_asm {
		push	flags
		popf
	}
}

extern void far _fastcall
_GrSetColor (color, r, g, b)
int	color;
int	r;
int	g;
int	b;
{
	short	flags;

	flags = _Disable ();
	outp (0x3c8, color);	(void)inp (0x080);
	outp (0x3c9, r >> 2);	(void)inp (0x080);
	outp (0x3c9, g >> 2);	(void)inp (0x080);
	outp (0x3c9, b >> 2);
	_Enable (flags);
}

extern void far
GrSetActive (long base)
{
	_ActiveBase = base;
}

extern int far
GrSetVisual (long base)
{
	return (_SetVS (base));
}

extern int far
GrVsync (void)
{
	time_t	i;

	i = time (0) + 2;
	while (inp (0x3da) & 0x08)	/* wait for end Vsync */
		if (i == time (0))
			return (1);	/* timed out */
	while (!(inp (0x3da) & 0x08))	/* wait for start Vsync */
		if (i == time (0))
			return (1);	/* timed out */
	return (0);
}

extern int far
int10 (regs)
REGISTERS	*regs;
{
	union REGS	inregs, outregs;
	struct SREGS    sregs;

	inregs.x.ax = regs->ax;
	inregs.x.bx = regs->bx;
	inregs.x.cx = regs->cx;
	inregs.x.dx = regs->dx;
	inregs.x.si = regs->si;
	inregs.x.di = regs->di;
	sregs.ds = regs->ds;
	sregs.es = regs->es;

	(void) int86x (0x10,&inregs,&outregs,&sregs);

	regs->ax = outregs.x.ax;
	regs->bx = outregs.x.bx;
	regs->cx = outregs.x.cx;
	regs->dx = outregs.x.dx;
	regs->si = outregs.x.si;
	regs->di = outregs.x.di;
	regs->ds = sregs.ds;
	regs->es = sregs.es;

	return (outregs.x.cflag);
}
